from typing import Any, Container, Dict, Generic, Iterable, Iterator, List, Optional, Set, Tuple, TypeVar, Union
import maya.api.OpenMaya as nom
import maya.OpenMaya as om
import PySide2.QtXml as qt
import maya.mel as mel
import shiboken2 as shiboken
import PySide2.QtSvg as QtSvg
import maya.cmds as cmds
import maya.OpenMayaUI as omui
import PySide2.QtGui as QtGui
import PySide2.QtXml as QtXml
import PySide2.QtWidgets as QtWidgets
import PySide2.QtCore as QtCore
import types
import maya.app.flux.ui.core as fui


from maya.app.flux.ui.core import pix
from PySide2.QtCore import Slot


if False:
    from typing import Dict, List, Tuple, Union, Optional

class StackedPage(QtWidgets.QWidget):
    def __init__(self, parent='None'): ...
    def hideEvent(self, e): ...
    def showEvent(self, e): ...
    def updateHeight(self): ...
    staticMetaObject : QtCore.QMetaObject
    
    visibilityChanged : QtCore.Signal


class StackedLayout(QtWidgets.QStackedWidget):
    def __init__(self, parent='None'): ...
    def hideEvent(self, e): ...
    def setIndex(self, i): ...
    def showEvent(self, e): ...
    def updateHeight(self): ...
    staticMetaObject : QtCore.QMetaObject
    
    visibilityChanged : QtCore.Signal


class LayoutInterface(object):
    def addSpacing(self, value): ...
    def addStretch(self, factor='1'): ...
    def addWidget(self, widget, stretchFactor='0', alignment='0'): ...
    def getFullName(self): ...
    def resizeDownstream(self): ...
    def resizeUpstream(self): ...
    def setAsMelParent(self): ...
    @staticmethod
    def addMethod(obj, methodName): ...
    @staticmethod
    def wrap(obj, layoutType): ...
    __dict__ : dictproxy
    
    __weakref__ : getset_descriptor


class IndentLayout(QtWidgets.QWidget):
    def __init__(self, name="''", parent='None', autoStretch='True'): ...
    def hideEvent(self, e): ...
    def setEnabled(self, enabled): ...
    def showEvent(self, e): ...
    def updateHeight(self): ...
    staticMetaObject : QtCore.QMetaObject
    
    visibilityChanged : QtCore.Signal


class ToolButton(fui.ImageButton):
    def __init__(self, imageName, **kwargs): ...
    staticMetaObject : QtCore.QMetaObject


class VerticalLayout(QtWidgets.QWidget):
    def __init__(self, offset='0', height='None', parent='None'): ...
    def hideEvent(self, e): ...
    def showEvent(self, e): ...
    def updateHeight(self): ...
    staticMetaObject : QtCore.QMetaObject
    
    visibilityChanged : QtCore.Signal


class ZeroVBoxLayout(QtWidgets.QVBoxLayout):
    def __init__(self, parent='None'): ...
    staticMetaObject : QtCore.QMetaObject


class TabLayout(QtWidgets.QTabWidget):
    def __init__(self, parent): ...
    def addTabNamed(self, widget, name): ...
    def currentTabChanged(self, index): ...
    def hideEvent(self, e): ...
    def showEvent(self, e): ...
    def updateHeight(self): ...
    staticMetaObject : QtCore.QMetaObject
    
    visibilityChanged : QtCore.Signal


class RadioImageGroup(QtWidgets.QWidget):
    def __init__(self, icons, currentIndex='0', parent='None'): ...
    def radioClicked(self, index): ...
    def setIndex(self, index): ...
    clicked : QtCore.Signal
    
    staticMetaObject : QtCore.QMetaObject


class Tab(QtWidgets.QWidget):
    def __init__(self): ...
    def hideEvent(self, e): ...
    def showEvent(self, e): ...
    def updateHeight(self): ...
    staticMetaObject : QtCore.QMetaObject
    
    visibilityChanged : QtCore.Signal


class Layout(QtWidgets.QWidget):
    """
    # Top Level Mandatory Layout
    """
    
    
    
    def __init__(self): ...
    def addWidgetToParent(self, parentName, widget): ...
    def hideEvent(self, e): ...
    def resizeEvent(self, e): ...
    def showEvent(self, e): ...
    def updateHeight(self, childHeight='None'): ...
    staticMetaObject : QtCore.QMetaObject
    
    visibilityChanged : QtCore.Signal


class HorizontalLayout(QtWidgets.QWidget):
    def __init__(self, offset='0', height='None', parent='None'): ...
    def hideEvent(self, e): ...
    def showEvent(self, e): ...
    def updateHeight(self): ...
    staticMetaObject : QtCore.QMetaObject
    
    visibilityChanged : QtCore.Signal


class IconButton(QtWidgets.QPushButton):
    def __init__(self, buttonName, iconName, parent='None'): ...
    staticMetaObject : QtCore.QMetaObject


class FrameLayout(fui.FrameWidget):
    def __init__(self, text, expanded='False'): ...
    def hideEvent(self, e): ...
    def setEnabled(self, enabled): ...
    def showEvent(self, e): ...
    def switchMode(self): ...
    def updateHeight(self): ...
    staticMetaObject : QtCore.QMetaObject
    
    visibilityChanged : QtCore.Signal


class ZeroHBoxLayout(QtWidgets.QHBoxLayout):
    def __init__(self, parent='None'): ...
    staticMetaObject : QtCore.QMetaObject


class Contents(QtWidgets.QWidget):
    def __init__(self, parent): ...
    def hideEvent(self, e): ...
    def showEvent(self, e): ...
    staticMetaObject : QtCore.QMetaObject
    
    visibilityChanged : QtCore.Signal




def wrapInstance(*args, **kwargs): ...
def unwrapInstance(*args, **kwargs): ...

